<template>
  <b-form class="form" @submit.prevent="submit">
    <b-modal size="sm" ref="returnMessage" hide-header centered>
      <div class="d-block text-center">
        <span>{{ returnedMessage }}</span>
      </div>
      <template slot="modal-footer">
        <b-button variant="primary" @click="close">{{ _('Ок') }}</b-button>
      </template>
    </b-modal>
    <b-container>
      <b-row>
        <b-col>
          <h3>Новая заявка</h3>
        </b-col>
      </b-row>
      <b-row>
        <b-col>
          <label>{{ _('Кабинет') }}:</label>
          <b-form-input
            type="text"
            :placeholder="_('Введите номер кабинета')"
            v-model="data.room"
          />
        </b-col>
      </b-row>
      <b-row>
        <b-col>
          <label>{{ _('Текст заявки') }}:</label>
          <b-form-textarea
            v-model="data.text"
            :placeholder="_('Опишите проблему максимально подробно')"
            :rows="3"
            required
          />
        </b-col>
      </b-row>
      <b-row>
        <b-col>
          <label>{{ _('Пароль от компьютера') }}:</label>
          <b-form-input
            type="password"
            :placeholder="_('Введите пароль от компьютера')"
            v-model="data.password"
          />
          <b-form-text>{{ _('Если пароль не требуется, оставьте поле пустым') }}</b-form-text>
        </b-col>
      </b-row>
      <b-row>
        <b-col>
          <b-button type="submit" variant="success">{{ _('Отправить') }}</b-button>
        </b-col>
      </b-row>
    </b-container>
  </b-form>
</template>

<script>
import moment from 'moment'

import { TASKS_ADD } from '../data/actions-types'

export default {
  name: 'NewTask',
  data () {
    return {
      data: {
        text: '',
        room: '',
        password: ''
      },
      dt_start: moment(),
      returnedMessage: ''
    }
  },
  methods: {
    submit () {
      this.$store.dispatch(TASKS_ADD, this.data).then((res) => {
        if (res) {
          this.returnedMessage = this._('Заявка успешно отправлена')
        } else {
          this.returnedMessage = this._('Что-то пошло не так. Попробуйте еще раз или обратитесь к системному Администратору другим образом')
        }
        this.$refs.returnMessage.show()
      })
    },
    close () {
      this.$refs.returnMessage.hide()
    }
  }
}
</script>

<style lang="scss">
.row {
  margin: 0 0 15px;
}
</style>
